import { Button, Image, MovableArea, MovableView, View } from '@tarojs/components'
import Taro, { useDidShow, useReady, useRouter } from '@tarojs/taro'
import type { ReactElement } from 'react'
import { useEffect, useLayoutEffect, useRef, useState } from 'react'
import classnames from 'classnames'
import Customer from '../customer'
import styles from './index.module.scss'
import { GetShoppingCartApi } from '@/api/shopCart'
import useCommonData from '@/use/useCommonData'
import { useSelector } from '@/reducers/hooks'
import { alert } from '@/common/common'
import { formatImgUrl } from '@/common/fotmat'

type ShowStatus = 'shop'|'customer'|'order'
interface param {
  children?: ReactElement | null
  onClick?: () => void
  showList?: ShowStatus[]
  orderInfo?: any
}
const MoveBtn = ({ children = null, onClick, showList = [], orderInfo }: param) => {
  const userInfo = useSelector(state => state.userInfo)
  // 获取购物车数据数量
  const { getShopCount, commonData } = useCommonData()

  const [screenHeight, setScreenHeight] = useState<{ shop?: number; customer?: number; order?: number }>({
    shop: 0,
    customer: 0,
    order: 0,
  })
  const [showMoveBtn, setShowMoveBtn] = useState(false)
  const screenWidthRef = useRef(0)
  useEffect(() => {
    Taro.nextTick(() => {
      const res = Taro.getSystemInfoSync()
      if (res.screenHeight) {
        const ratio = 750 / res.screenWidth
        const num = res.screenHeight * ratio
        setScreenHeight(() => ({ shop: num - 460, customer: num - 580, order: num - 700 }))
        screenWidthRef.current = res.screenWidth / 2
      }
      setShowMoveBtn(true)
    })
  }, [])

  useDidShow(() => {
    getShopCount()
  })

  const onShow = (val: ShowStatus) => {
    if (showList.length <= 0) { return true }
    return showList.includes(val)
  }

  const onPhone = () => {
    if (!userInfo?.adminUserInfo?.sale_user_phone) { return alert.error('手机号不能为空') }
    Taro.makePhoneCall({
      phoneNumber: userInfo?.adminUserInfo?.sale_user_phone,
    })
  }

  const [customer_service_show, set_customer_service_show] = useState(false)
  const customerClose = () => {
    set_customer_service_show(false)
  }

  return (
    <MovableArea className={styles.movableItem}>
      {children}
      {onShow('shop') && <MovableView
        onClick={onClick}
        className={styles.moveBtn}
        direction="all"
        inertia
        x="630rpx"
        y={`${screenHeight.shop}rpx`}
      >
        <View className={classnames('iconfont', 'icon-gouwuche', styles.shop_icon)}></View>
        {commonData.shopCount > 0 && <View className={styles.product_num}>{commonData.shopCount > 99 ? '99+' : commonData.shopCount}</View>}
      </MovableView>}
      {onShow('order') && <MovableView
        className={styles.moveBtn}
        direction="all"
        inertia
        x="630rpx"
        y={`${screenHeight.order}rpx`}
      >
        <View className={classnames('iconfont', 'icon-kefu', styles.shop_icon)}>
          <Button
            className={styles.wxBtn}
            openType="contact"
            sendMessageTitle={orderInfo?.order_no}
            showMessageCard
            sendMessagePath={`/pages/order/index?id=${orderInfo?.id}`}
          ></Button>
        </View>
      </MovableView>}
      {onShow('customer') && <MovableView
        className={classnames(styles.moveBtn, styles.no_bg_moveBtn)}
        direction="all"
        inertia
        x="630rpx"
        onClick={onPhone}
        y={`${screenHeight.customer}rpx`}
      >
        <Image mode="aspectFit" src={formatImgUrl('/mall/float_button_customer_service.png')} />
      </MovableView>}
      <Customer show={customer_service_show} onClose={customerClose} />
    </MovableArea>
  )
}

export default MoveBtn
